<?php
chdir('../../');
include_once("./include/auth.php");
include_once("./include/top_header.php");

//Setup of base parameters and get info.
$parameter = "";
$show = '';
$iplevel = "";  
$coverage = '';

if (!isset($_REQUEST["show"])) { 
$show = '';
}else{
$show = $_REQUEST["show"];
}
if (!isset($_REQUEST["parameter"])){
	$parameter = "";
}else{
	$parameter = $_REQUEST["parameter"];
}
if (!isset($_REQUEST["iplevel"])){
	$iplevel = "";
}else{
	$iplevel = $_REQUEST["iplevel"];  
}
if (!isset($_REQUEST["coverage"])){
	$coverage = 0;
}else{
	$coverage = $_REQUEST["coverage"];
}


$apiKey = read_config_option("gpsmap_apikey");
$initialLong = read_config_option("gpsmap_longitude");
$initialLat = read_config_option("gpsmap_latutude");
$initialzoom = read_config_option("gpsmap_zoom");
$initialheight = read_config_option("gpsmap_height");
$towerId = read_config_option("gpsmap_towerhostid");
$fillColor = read_config_option("gpsmap_fillcolor");
$liColor = read_config_option("gpsmap_licolor");
$liWidth = read_config_option("gpsmap_liwidth");
$fillOpa = read_config_option("gpsmap_fillopa");
$liOpa = read_config_option("gpsmap_liopa");
$circleQuality = read_config_option("gpsmap_circlequality");

//insurance that the basic options are set.
if(($apiKey =="")||($initialLong=="")||($initialLat=="")){
	$show = 'setup';
}

if($initialzoom ==""){
	$initialzoom = "10";
}
if($initialheight==""){
	$initialheight = "300";
}

$doc = '';
$body = "";
              
switch ($show) {
//selected nodes	
	case 'setup':
		$body = "Please make sure to properly configure GPS Map first under settings -> misc";
		break;
//this is meant to select all those in certain IP ranges.
//In our case our different IP regions		
	case 'region': 
		if (!$iplevel) { 
			$iplevel = 1;
		}
		if (!$parameter) { 
			$parameter = "";
		}
		region($parameter,$iplevel);    
		break;    
//show all nodes		
	default:
		$body .= "<div style=\"font-size:12px; background-color:#cccccc; width:100%; height:14px;\"><a href=\"./gpsmap.php?show=region&coverage=0\">IP Analysis</a></div>";
		$body .= "<div style=\"font-size:12px; background-color:#cccccc; width:100%; height:14px;\"><a href=\"./gpsmap.php?show=region&coverage=1\">IP Analysis with Coverage</a></div>";
		showAll();
		break;
}

function showAll(){
//we are going to get every node and send that through our system 

	$result = mysql_query("SELECT id FROM host");    
	global $coverage;
	$idArray;
	$numberOfRows = mysql_num_rows($result);
	
	if ($numberOfRows == 0) {
		echo "No hosts found, nothing to map out.";
	    	exit;
	}else{
		for($i = 0;$i < $numberOfRows;$i++){
			$row = mysql_fetch_assoc($result);
			$idArray[$i] = $row["id"];
			
		}
	}
	if ($coverage == 1){
	coverageXML($idArray);
	}else{
	xmlCreate($idArray);
	}
}

function region($preemptive,$ipLevel){
	global $body;
	global $coverage;
	//we are going to parse every node and sort them by region numbers, IE the IP range seleced in the setup.
	$result = mysql_query("SELECT hostname,id FROM host");
	$numberOfRows = mysql_num_rows($result);
	if ($numberOfRows == 0) {
		echo "No hosts found, nothing to map out.";
	    	exit;
	}else{
		$back = "";
		$idarray;
		$ipcountarray = array($numberOfRows);
		$iparray = array($numberOfRows);
		for($i = 0;$i < $numberOfRows;$i++){
			$host = mysql_fetch_assoc($result);
			
			//Here is where we confirm hostname is an IP address
			$tempIParray = split('[.]',$host["hostname"]);
			
			//greater than 3 because we want IP's
			if ((sizeof($tempIParray)) >3){		

			list($first, $second, $third, $fourth) = $tempIParray;
				
				//sort by top level, and display all top IP range so they can be selected, 
				//and iterate this down through level 4
				
				//if preemptive level is met we want to display the lower ones.                                    
				//for 1 we want to display all top level IP
				if($ipLevel == 1){
					if(!in_array($first,$ipcountarray)){
						$ipcountarray[] = $first;
						$iparray[] = "<a href=\"./gpsmap.php?show=region&parameter=".$first."&iplevel=2&coverage=".$coverage."\">IP ".$first."</a><br/>";
					}
				}
				elseif($ipLevel == 2){
					if(!strcasecmp($preemptive,$first)){
						if(!in_array($first.$second,$ipcountarray)){
							$ipcountarray[] = $first.$second;
							$iparray[] = "<a href=\"./gpsmap.php?show=region&parameter=".$first.$second."&iplevel=3&coverage=".$coverage."\">IP ".$first.".".$second."</a><br/>";
						}
						$back = "<a href=\"./gpsmap.php?show=region&coverage=".$coverage."\"><u>Go Back</u></a><br/>";
						//echo $host["id"];						
						$idarray[]=$host["id"];
					}
				}
				elseif($ipLevel == 3){ 
					if(!strcasecmp($preemptive,$first.$second)){
						if(!in_array($first.$second.$third,$ipcountarray)){
						$ipcountarray[] = $first.$second.$third;
						$iparray[] = "<a href=\"./gpsmap.php?show=region&parameter=".$first.$second.$third."&iplevel=4&coverage=".$coverage."\">IP ".$first.".".$second.".".$third."</a><br/>";
						}
						$back = "<a href=\"./gpsmap.php?show=region&parameter=".$first."&iplevel=2&coverage=".$coverage."\"><u>Go Back</u></a><br/>";
						//echo $host["id"];
						$idarray[]=$host["id"];
					}
				}
				elseif($ipLevel == 4){ 
					if(!strcasecmp($preemptive,$first.$second.$third)){
						if(!in_array($first.$second.$third,$ipcountarray)){
						$ipcountarray[] = $first.$second.$third;
						$iparray[] = "<a href=\"./gpsmap.php?show=region&parameter=".$first.$second.$third."&iplevel=4&coverage=".$coverage."\">IP ".$first.".".$second.".".$third."</a><br/>";
						}
						$back = "<a href=\"./gpsmap.php?show=region&parameter=".$first.$second."&iplevel=3&coverage=".$coverage."\"><u>Go Back</u></a>";
						//echo $host["id"];
						$idarray[]=$host["id"];
					}
				}                          
				
				
				}
			}
			//print out the information we have gathered.
			$body .= "<div id=\"gpstopmenu\" style=\"width:100%; height:75px; background-color:lightgrey; \">";
			$body .= "<div id=\"gpsnav\"style=\"width:75px; height:75px; background-color:lightgrey; float:left; position:relative;\"><a href=\"./gpsmap.php?show=region&coverage=".$coverage."\"><u>Start Over</u></a><br/>";
			$body .= $back;
			$body .= "</div>";
			$tempHold = " ";
			for($i = 1;$i < count($iparray); $i++){
				$tempHold .= $iparray[$i];
				if($i%5 == 0){
					$body .= "<div id=\"iplevels\" style=\"width:100px; height:75px; float:left; background-color:lightgrey; position: relative;\">".$tempHold."</div>";
					$tempHold = " ";   
				} 
			}                     
			//print out what is left
			if($tempHold != " "){
				$body .= "<div id=\"iplevels\" style=\"width:100px; height:75px; float:left; background-color:lightgrey; position: relative;\">".$tempHold."</div>";
			}
			$body .="</div>";

			if($ipLevel == 1){
				showAll();
			}elseif(($coverage == 0) && ($ipLevel != 1)){
				//echo ("Here 1");
				xmlCreate($idarray);
			}elseif (($coverage == 1)&& ($ipLevel != 1)){
				//echo ("Here 2");
				coverageXML($idarray);
				}
			}
	
echo $body;
$body ="";
}


function parseToXML($htmlStr) 
{ 
$xmlStr=str_replace('<','&lt;',$htmlStr); 
$xmlStr=str_replace('>','&gt;',$xmlStr); 
$xmlStr=str_replace('"','&quot;',$xmlStr); 
$xmlStr=str_replace("'",'&#39;',$xmlStr); 
$xmlStr=str_replace("&",'&amp;',$xmlStr); 
return $xmlStr; 
} 

function calcMeters ($Lat1, $Lon1, $Lat2, $Lon2){

$difference= (6378.7*3.1415926*sqrt(($Lat2-$Lat1)*($Lat2-$Lat1) + cos($Lat2/57.29578)*cos($Lat1/57.29578)*($Lon2-$Lon1)*($Lon2-$Lon1))/180);
//This was old one.
//$Difference =  6378.7 * acos(  sin($Lat1/57.2958) * sin($Lat2/57.2958) + cos($Lat1/57.2958) * cos($Lat2/57.2958) * cos($Lon2/57.2958 - $Lon1/57.2958));
//echo $difference." <-- Diff <br />";
return $difference;
}

function coverageXML($hostIdArray){
require_once ("towers_class.php");
global $towerId;
$towerArray;
// I need to compare the first 3 sets in the ip address and for each tower I 
// need to get the furthest host and compare the distance.
// Looks like We will need to use objects, because I have no Idea how many towers there are.


//gotta get ONLY towers in the hostIdArray this can reduce the number of SQL calls <--- Gotta fix

// so first lets get all the towers
	$towerresult = mysql_query("SELECT * FROM host WHERE host_template_id={$towerId}");
		while($row = mysql_fetch_array($towerresult,MYSQL_BOTH)){
			$tempIParray = split('[.]',$row["hostname"]);
			list($first, $second, $third, $fourth) = $tempIParray;
			$towerArray[] = new towerDistance($row['latitude'],$row['longitude'],0,$first.$second.$third,$row['description'],$row['hostname'],$row['availability']);
		}
			
//now we need to compare all the hosts that are in our ID array, and then generate the XML to perform google magic
$doc = '<markers>';
//echo count($hostIdArray);
	foreach($hostIdArray as $hostId){ 
		$result = mysql_query("SELECT * FROM host WHERE id={$hostId}"); 
		$row = mysql_fetch_array($result,MYSQL_BOTH); 
		 if(isset($row['latitude'])&&isset($row['longitude'])&&($row['latitude'] != '')&&($row['latitude'] != '')){
			 //only include those that have a set lat and long
			if (($row['latitude'] != '0')&&($row['latitude'] != '0')){    
				
			//now lets check IP against out tower array and caclulate distance.
			$tempIParray = split('[.]',$row["hostname"]);
			list($first, $second, $third, $fourth) = $tempIParray;
			for($i=0;$i<count($towerArray);$i++){
				if (($towerArray[$i]->towerIprange == $first.$second.$third)&&($row['host_template_id'] != $towerId)){
				       $distance = calcMeters($towerArray[$i]->towerLat,$towerArray[$i]->towerLong, $row['latitude'], $row['longitude']);
					if ($distance > $towerArray[$i]->towerRadius){
						$towerArray[$i]->towerRadius = $distance;

						//add the tower to XML
						$tower = $towerArray[$i];

						$doc .= '<marker ';
						//gotta determine type based on host type, 
						//This is where people can define custom hosts types
						$type= $towerId;
						include("./plugins/gpsmap/custom_hosts.php");
						//insure nothing will be invalid.
						$doc .= 'name="' . parseToXML($tower->towerDescription) . '" ';
						$doc .= 'address="' . parseToXML($tower->towerHostname) . '" ';
						$doc .= 'lat="' . parseToXML($tower->towerLat) . '" ';
						$doc .= 'lng="' . parseToXML($tower->towerLong) . '" ';
						$doc .= 'type="' . parseToXML($type) . '" ';
						$doc .= 'radius="' . parseToXML($tower->towerRadius) . '" '; //this is in miles
						$doc .= 'availability="' . parseToXML($tower->towerAvail) . '" ';
						$doc .= '/>'; 
					}
				}
			}
			}
			//echo $row['host_template_id'];
			if($row['host_template_id'] != $towerId){
				
				//This is to display all non towers.
				$doc .= '<marker ';
				//gotta determine type based on host type, 
				//This is where people can define custom hosts types
				$type= $row['host_template_id'];
				include("./plugins/gpsmap/custom_hosts.php");
				//insure nothing will be invalid.
				$doc .= 'name="' . parseToXML($row['description']) . '" ';
				$doc .= 'address="' . parseToXML($row['hostname']) . '" ';
				$doc .= 'lat="' . parseToXML($row['latitude']) . '" ';
				$doc .= 'lng="' . parseToXML($row['longitude']) . '" ';
				$doc .= 'type="' . parseToXML($type) . '" ';
				$doc .= 'availability="' . $row['availability'].'" ';
				$doc .= 'radius="0"';
                	        $doc .= '/>'; 
			}
		

		}
		}
		
		$doc .= '</markers>';	
		$f = fopen("./plugins/gpsmap/XML/gpsXML.xml","w");
		fwrite($f, $doc);
		fclose($f);
}    	

function xmlCreate($hostsIdArray){     
	// Start XML file, create parent node
	$doc = '<markers>';
	//step through each node selected and get info and shove it to xml
	foreach($hostsIdArray as $hostId){
		//echo ("<br />");
		//echo $hostId;
		$result = mysql_query("SELECT * FROM host WHERE id={$hostId}"); 
		$row = mysql_fetch_array($result,MYSQL_BOTH); 
		  if(isset($row['latitude'])&&isset($row['longitude'])){
			if (($row['latitude'] != '')&&($row['latitude'] != '')){                     
				//Add a new node to XML
				$doc .= '<marker ';
				
				//gotta determine type based on host type, 
				//This is where people can define custom hosts types
				
				$type= $row['host_template_id'];
				
				include("./plugins/gpsmap/custom_hosts.php");
				
				//insure nothing will be invalid.
				$doc .= 'name="' . parseToXML($row['description']) . '" ';
				$doc .= 'address="' . parseToXML($row['hostname']) . '" ';
				$doc .= 'lat="' . parseToXML($row['latitude']) . '" ';
				$doc .= 'lng="' . parseToXML($row['longitude']) . '" ';
				$doc .= 'type="' . parseToXML($type) . '" ';
				$doc .= 'availability="' . $row['availability'].'" ';
				$doc .= 'radius="0"';
                	        $doc .= '/>'; 
			}
		}
	}
	$doc .= '</markers>';
	//write that xml
	$f = fopen("./plugins/gpsmap/XML/gpsXML.xml","w");
	fwrite($f, $doc);
	fclose($f);
}    
if ($show != 'setup'){?>                                           

<script src="http://maps.google.com/maps?file=api&v=2&key=<? echo $apiKey ?>"
            type="text/javascript"></script>
    <script type="text/javascript">
    //<![CDATA[
    <? $gmapicons = file_get_contents("./plugins/gpsmap/host_icons.php"); 
    echo $gmapicons; ?>
    
    //This is all standard stuff from the google API
    function gload() {
//need to get some variables first before things get rolling to much
var liColor = "<?= $liColor ?>";
var liWidth = "<?= $liWidth ?>";
var liOpa = "<?= $liOpa ?>";
var fillColor = "<?= $fillColor ?>";
var fillOpa = "<?= $fillOpa ?>";
var circleQuality = "<?= $circleQuality ?>";

      if (GBrowserIsCompatible()) {
        var map = new GMap2(document.getElementById("map"));
        map.addControl(new GSmallMapControl());
        map.addControl(new GMapTypeControl());
        map.setCenter(new GLatLng(<?= $initialLat ?>, <?= $initialLong ?>), <?= $initialzoom ?>);
	//set to our XML path
	GDownloadUrl("./XML/gpsXML.xml", function(data) {
          var xml = GXml.parse(data);
          var markers = xml.documentElement.getElementsByTagName("marker");
          for (var i = 0; i < markers.length; i++) {
            var name = markers[i].getAttribute("name");
            var address = markers[i].getAttribute("address");
            var type = markers[i].getAttribute("type");
	     var availability = markers[i].getAttribute("availability");
            var point = new GLatLng(parseFloat(markers[i].getAttribute("lat")),parseFloat(markers[i].getAttribute("lng")));
            var marker = createMarker(point, name, address, type, availability);
	     map.addOverlay(marker);
	     //if radius is set, we need to draw a circle.
		if(markers[i].getAttribute("radius")>0){
			map.addOverlay(drawCircle(point,markers[i].getAttribute("radius"),circleQuality,liColor,liWidth,liOpa,fillColor,fillOpa));
		}
          }
	});
      }
    }                                                    
function drawCircle(center, radius, nodes, liColor, liWidth, liOpa, fillColor, fillOpa)
{

	//calculating km/degree
	var latConv = center.distanceFrom(new GLatLng(center.lat()+0.1, center.lng()))/100;
	var lngConv = center.distanceFrom(new GLatLng(center.lat(), center.lng()+0.1))/100;

	//Loop 
	var points = [];
	var step = parseInt(360/nodes)||10;

	for(var i=0; i<=360; i+=step)
	{
	var pint = new GLatLng(center.lat() + (radius/latConv * Math.cos(i * Math.PI/180)), center.lng() + (radius/lngConv * Math.sin(i * Math.PI/180)));
	points.push(pint);
	}
	points.push(points[0]); // Closes the circle

	fillColor = fillColor||"#0055ff";
	liColor = liColor||"#0055ff";
	liWidth = liWidth||2;
	fillOpa = fillOpa||.2;
	liOpa = liOpa||.8;

	var poly = new GPolygon(points,liColor,liWidth,liOpa,fillColor,fillOpa);
	return poly;

}
                                                                     
    function createMarker(point, name, address, type, availability) {
      var marker = new GMarker(point, customIcons[type]);
      
      //This defines what is put in the pop-up bubbles when the icon is clicked
      var html = "<b>" + name + "</b> <br/>" + address + "<br/> Avalability: " + availability + "<br/> Type: " + type;
      GEvent.addListener(marker, 'click', function() {
        marker.openInfoWindowHtml(html);
      });
      return marker;
    }                          
    //]]>
  </script>
  </head> 
                                
       
<?
}


$body .= "<body onload=\"gload()\" onunload=\"GUnload()\"><div id=\"map\" style=\"position:relative; float:left; width:100%; height:". $initialheight .";\"></div></body>";   
echo $body;
?>